diff --git a/src/john.c b/src/john.c
index 31d610f217..b30146d41e 100644
--- a/src/john.c
+++ b/src/john.c
@@ -1216,6 +1216,25 @@ static void john_load(void)
 				log_event("Starting a new session");
 			log_event("Loaded a total of %s", john_loaded_counts());
 			/* make sure the format is properly initialized */
+
+#if HAVE_OPENCL && OS_FORK
+	/*
+	 * Check if the --devices list contains more OpenCL devices than the
+	 * number in -fork.
+	 * Exceptions: at least mscash2-OpenCL has built-in multi-device
+	 * support.
+	 */
+	if (strstr(database.format->params.label, "-opencl") &&
+	    !strstr(database.format->params.label, "mscash2-opencl") &&
+	    options.fork < get_number_of_devices_in_use()) {
+		fprintf(stderr, "To fully use the %d devices requested, "
+		    "you must specify --fork=%d\n",
+		    get_number_of_requested_devices(),
+		    get_number_of_devices_in_use());
+		error();
+	}
+#endif
+
 #if HAVE_OPENCL
 			if (!(options.acc_devices->count && options.fork &&
 			      strstr(database.format->params.label, "-opencl")))
